--- makepkg-old	2008-03-05 08:47:23.939439843 +0800
+++ makepkg-new	2008-03-05 08:47:22.116093249 +0800
@@ -48,6 +48,7 @@
 FORCE=0
 INFAKEROOT=0
 GENINTEG=0
+GETINTEG=0
 INSTALL=0
 NOBUILD=0
 NODEPS=0
@@ -489,7 +490,7 @@
 }
 
 generate_checksums() {
-	msg "$(gettext "Generating checksums for source files...")"
+	msg "$(gettext "Generating %s for source files...")" "${DB_CHECKSUMS}sums"
 	plain ""
 
 	local integ
@@ -543,6 +544,17 @@
 	done
 }
 
+insert_checksums() {
+	warning "$(gettext "You will only get %s for %s sources")" "${DB_CHECKSUMS}sums" "$CARCH"
+	msg "$(gettext "Creating backup of %s as %s")" "$BUILDSCRIPT" ".$BUILDSCRIPT"
+	cp $startdir/$BUILDSCRIPT $startdir/.$BUILDSCRIPT
+	
+	sed -i '/md5sums=(/,/)/d' $startdir/$BUILDSCRIPT
+	generate_checksums >> $startdir/$BUILDSCRIPT
+	msg "$(gettext "Successfully inserted %s into %s")" "${DB_CHECKSUMS}sums" "$BUILDSCRIPT"
+	return 0 # we will probably need to go back to --install
+}
+
 check_checksums() {
 	local integ
 	for integ in ${INTEGRITY_CHECK[@]}; do
@@ -1076,6 +1088,7 @@
 	echo "$(gettext "  -e, --noextract  Do not extract source files (use existing src/ dir)")"
 	echo "$(gettext "  -f, --force      Overwrite existing package")"
 	echo "$(gettext "  -g, --geninteg   Generate integrity checks for source files")"
+	printf "$(gettext "  -G, --getinteg   Generate and insert checksums into %s")\n" "$BUILDSCRIPT"
 	echo "$(gettext "  -h, --help       This help")"
 	echo "$(gettext "  -i, --install    Install package after successful build")"
 	echo "$(gettext "  -L, --log        Log package build process")"
@@ -1143,8 +1156,8 @@
 SRCDEST=${SRCDEST:-$startdir} #default to $startdir if undefined
 
 # Parse Command Line Options.
-OPT_SHORT="AbcCdefFghiLmop:rRsSV"
-OPT_LONG="ignorearch,asroot,builddeps,clean,cleancache,nodeps,noextract,force,forcever:,geninteg,help,holdver"
+OPT_SHORT="AbcCdefFgGhiLmop:rRsSV"
+OPT_LONG="ignorearch,asroot,builddeps,clean,cleancache,nodeps,noextract,force,forcever:,geninteg,getinteg,help,holdver"
 OPT_LONG="$OPT_LONG,install,log,nocolor,nobuild,rmdeps,repackage,source,syncdeps,usesudo,version"
 # Pacman Options
 OPT_LONG="$OPT_LONG,noconfirm,noprogressbar"
@@ -1175,6 +1188,7 @@
 		--forcever)       shift; FORCE_VER=$1;;
 		-F)               INFAKEROOT=1 ;;
 		-g|--geninteg)    GENINTEG=1 ;;
+		-G|--getinteg)    GETINTEG=1 ;;
 		--holdver)        HOLDVER=1 ;;
 		-i|--install)     INSTALL=1 ;;
 		-L|--log)         LOGGING=1 ;;
@@ -1354,7 +1368,7 @@
 devel_update
 
 if [ -f "$PKGDEST/${pkgname}-${pkgver}-${pkgrel}-${CARCH}${PKGEXT}" \
-     -a "$FORCE" = "0" -a "$GENINTEG" = "0" -a "$SOURCEONLY" = "0" ]; then
+     -a "$FORCE" = "0" -a "$GENINTEG" = "0" -a "$GETINTEG" = "0" -a "$SOURCEONLY" = "0" ]; then
 	if [ "$INSTALL" = "1" ]; then
 		warning "$(gettext "A package has already been built, installing existing package...")"
 		install_package
@@ -1400,11 +1414,11 @@
 fi
 
 # fix flyspray bug #5973
-if [ "$NODEPS" = "1" -o "$GENINTEG" = "1" -o "$NOBUILD" = "1" -o "$REPKG" = "1" ]; then
+if [ "$NODEPS" = "1" -o "$GENINTEG" = "1" -o $GETINTEG = "1" -o "$NOBUILD" = "1" -o "$REPKG" = "1" ]; then
 	if [ "$NODEPS" = "1" ]; then
 		warning "$(gettext "Skipping dependency checks.")"
 	fi
-	# skip printing a warning message for the others: geninteg, nobuild, repkg
+	# skip printing a warning message for the others: geninteg, getinteg, nobuild, repkg
 elif [ $(type -p pacman) ]; then
 	unset pkgdeps # Set by resolve_deps() and used by remove_deps()
 	deperr=0
@@ -1436,6 +1450,12 @@
 	exit 0 # $E_OK
 fi
 
+if [ "$GETINTEG" = "1" ]; then
+	download_sources
+	insert_checksums
+	# we don't exit to facilitate --install
+fi
+
 if [ "$NOEXTRACT" = "1" -o "$REPKG" = "1" ]; then
 	warning "$(gettext "Skipping source retrieval        -- using existing src/ tree")"
 	warning "$(gettext "Skipping source integrity checks -- using existing src/ tree")"
